<template>
  <div>
    <nav
      class="z-10 fixed w-full flex justify-center bg-teal-light p-6"
      role="navigation"
      aria-label="main navigation"
    >
      <div class="container mx-auto mx-4 flex items-center">
        <router-link
          to="/"
          class="text-black mr-12 no-underline"
        >
          <h3 class="">
            ANCORE
          </h3>
        </router-link>

        <ul class="list-reset flex">
          <component
            :is="'Link'"
            to="/"
            text="Home"
          />

          <component
            :is="'Link'"
            v-if="shouldDisplayConfigurationRoute"
            to="/configuration"
            text="Configuration"
          />

          <component
            :is="'Link'"
            v-if="shouldDisplayResultsRoute"
            to="/results"
            text="Results"
          />

          <component
            :is="'Link'"
            to="/about"
            text="About"
          />
        </ul>
      </div>
    </nav>

    <main class="pt-24 px-4 container mx-auto">
      <transition
        enter-active-class="animated fadeIn fast"
        leave-active-class="animated fadeOut fast"
        mode="out-in"
      >
        <router-view class="" />
      </transition>
    </main>

    <footer class="container border-t p-4 sm:px-0 mt-8 mx-auto">
      <div class="container">
        <div class="flex justify-between">
          <div>
            <p class="font-bold">
              ANCORE
            </p>

            <p class="my-2">
              What do you think?
              <button
                class="btn inline"
                @click="showFeedback = true"
              >
                Give us feedback!
              </button>
            </p>

            <modal v-model="showFeedback">
              <Feedback @save="showFeedback = false" />
            </modal>

            <p class="text-sm opacity-75">
              For additional informations, please contact
              <a href="mailto:adnene.belfodil@insa-lyon.fr">
                Adnene Belfodil
              </a>
              and
              <a href="mailto:charles.de-lacombe@insa-lyon.fr">
                Charles de Lacombe
              </a>
            </p>
          </div>

          <div class="text-right">
            <p>
              Version 1.1
            </p>

            <p>
              <router-link to="legal">
                Legal notices
              </router-link>
            </p>
          </div>
        </div>
      </div>
    </footer>

    <StatusBar />
  </div>
</template>

<script lang="tsx">
import { Vue, Component, Watch } from 'vue-property-decorator'
import { State } from 'vuex-class'

import _ from 'lodash/fp'

import Feedback from '@/components/Feedback.vue'
import Modal from '@/components/Modal.vue'
import StatusBar from '@/components/StatusBar.vue'

import Dataset from '@/types/Dataset'

const Link = Vue.extend({
  functional: true,

  props: {
    to: { type: String, required: true },
    text: { type: String, required: true }
  },

  render (h, { props }) {
    return (
      <li class='mr-6'>
        <router-link
          class='text-black hover:text-teal-lighter mr-4 no-underline focus:outline-none'
          to={ props.to }
        >
          { props.text}
        </router-link>
      </li>
    )
  }
})

@Component({
  components: {
    Feedback,
    Link,
    Modal,
    StatusBar
  }
})
export default class App extends Vue {
  @State dataset: Dataset
  @State userData: any[]
  @State settings: any
  @State userID: string
  @State jobID: string

  isActive = false
  showFeedback = false

  get shouldDisplayConfigurationRoute () {
    return !_.isEmpty(this.userData) && !_.isEmpty(this.settings)
  }

  get shouldDisplayResultsRoute () {
    return !_.isEmpty(this.userID) && !_.isEmpty(this.jobID)
  }

  @Watch('dataset')
  onDatasetChanged () {
    this.$store.dispatch('fetch_dataset', this.dataset)
  }

  mounted () {
    this.$store.dispatch('fetch_datasets')
    this.$store.dispatch('fetch_examples')
  }

  toggleMenu () {
    this.isActive = !this.isActive
  }
}
</script>

<style src="@/assets/app.css"></style>
